<ion-grid
  *transloco="let t"
  class="full-width-grid ion-no-padding flex-list-large"
>
  <ion-col *ngIf="!isConnected">
    <lib-connectivity-error-handling-card
      [show]="true"
      [title]="t('feature_waste.connectivity-error.title_settings')"
    >
    </lib-connectivity-error-handling-card>
  </ion-col>

  @if (isConnected) {
    <div class="flex-list-medium">
      <div class="flex-list-lines">
        <div class="header">
          {{ t('feature_waste.waste-settings-menu.header_pick_ups') }}
        </div>
        <div
          [innerHTML]="
            t('feature_waste.waste-settings-menu.subheader_pick_ups')
          "
          class="location-section-subheader"
        ></div>
      </div>
      <ion-row class="flex-list-minor-min">
        <div class="search-bar-section-header">
          {{ t('feature_waste.waste-settings-menu.pick_up_area') }}
        </div>
        <ion-row class="search-bar-row">
          <div class="search-bar-header">
            {{ t('feature_waste.waste-settings-menu.street') }}
          </div>
          <ion-searchbar
            mode="md"
            inputmode="text"
            enterkeyhint="search"
            [formControl]="searchControl"
            [placeholder]="
              collectionStreet ?? t('feature_waste.waste-settings-menu.search')
            "
          ></ion-searchbar>
        </ion-row>
        <ion-row
          *ngIf="isLoadingSearch"
          class="ion-justify-content-center searchbar-loading-indicator"
        >
          <ion-spinner name="dots"></ion-spinner>
        </ion-row>
        <ion-row *ngIf="searchErrored" class="ion-justify-content-center">
          <div class="flex-list-minor-min search-item-suggestion">
            {{ t('feature_waste.waste-settings-menu.search_error') }}
          </div>
        </ion-row>
        <ion-row
          *ngIf="searchPerformed && !hasSearchResults && !searchErrored"
          class="ion-justify-content-center"
        >
          <div class="flex-list-minor-min search-item-suggestion">
            {{ t('feature_waste.waste-settings-menu.search_no_results') }}
          </div>
        </ion-row>
        <ion-row
          *ngIf="savingLocalStorageErrored"
          class="ion-justify-content-center"
        >
          <div class="flex-list-minor-min search-item-suggestion">
            {{
              t('feature_waste.waste-settings-menu.saving_local_storage_error')
            }}
          </div>
        </ion-row>
        <div
          *ngIf="searchPerformed && hasSearchResults && !searchErrored"
          class="flex-list-minor-min search-item-list"
          aria-live="polite"
          aria-atomic="true"
        >
          <button
            *ngFor="let wastedate of searchResults"
            class="search-item-suggestion"
            (click)="saveStreetToLocalStorage(wastedate.id, wastedate.street)"
          >
            {{ wastedate.street }}
          </button>
        </div>
      </ion-row>

      <div
        [ngClass]="{ disabled: !collectionAreaId }"
        class="flex-list-minor-min"
      >
        <div class="header-agreement">
          {{
            t('feature_waste.waste-settings-menu.individual_agreement_header')
          }}
        </div>
        <ion-radio-group
          class="flex-list-minor-min"
          [(ngModel)]="residualIndividualAgreement"
          (ionChange)="updateIndividualAgreement($event)"
        >
          <ion-radio
            mode="md"
            labelPlacement="end"
            alignment="start"
            justify="start"
            [value]="false"
          >
            {{ t('feature_waste.waste-settings-menu.individual_agreement_no') }}
          </ion-radio>
          <ion-radio
            mode="md"
            labelPlacement="end"
            alignment="start"
            justify="start"
            [value]="true"
          >
            {{
              t('feature_waste.waste-settings-menu.individual_agreement_yes')
            }}
          </ion-radio>
        </ion-radio-group>
      </div>
    </div>

    @if (!showNotificationSettings) {
      <div
        class="location-section-subheader"
        [innerHTML]="
          t('feature_waste.waste-settings-menu.notifications_disabled_info')
        "
      ></div>
    }
    <div class="flex-list-small" *ngIf="showNotificationSettings">
      <lib-checkbox-setting
        #notificationCheckbox
        [checked]="notificationsEnabled"
        (checkedChange)="toggleNotifications()"
        [localizedTitle]="
          t('feature_waste.waste-settings-menu.header_notifications')
        "
        [ngClass]="{ disabled: !collectionAreaId }"
      ></lib-checkbox-setting>
      <ion-radio-group
        [ngClass]="{ disabled: !notificationsEnabled }"
        class="notification-radio-group flex-list-medium"
        [(ngModel)]="dayBefore"
        (ionChange)="updateNotifications()"
      >
        <div class="flex-list-minor">
          <ion-radio
            mode="md"
            labelPlacement="end"
            alignment="start"
            justify="start"
            [value]="reminderDay.dayBefore"
          >
            <div class="flex-list-minor-min">
              {{ t('feature_waste.waste-settings-menu.the_day_before') }}
              <ion-row class="date-time-container flex-list-small">
                <span class="set-time-text">{{
                  t('feature_waste.waste-settings-menu.at')
                }}</span>
                <ion-datetime-button
                  datetime="dateTimeBefore"
                ></ion-datetime-button>
                <ion-modal [keepContentsMounted]="true">
                  <ng-template>
                    <ion-datetime
                      presentation="time"
                      id="dateTimeBefore"
                      mode="ios"
                      (ionChange)="onDateTimeChange(reminderDay.dayBefore)"
                      [(ngModel)]="dateTimeBefore"
                      [showDefaultButtons]="true"
                      [doneText]="t('ui.date-time.done')"
                      [cancelText]="t('ui.date-time.cancel')"
                    ></ion-datetime>
                  </ng-template>
                </ion-modal>
              </ion-row>
            </div>
          </ion-radio>

          <ion-radio
            mode="md"
            labelPlacement="end"
            alignment="start"
            justify="start"
            [value]="reminderDay.sameDay"
          >
            <div class="flex-list-minor-min">
              {{ t('feature_waste.waste-settings-menu.the_day_of_collection') }}
              <ion-row class="date-time-container flex-list-small">
                <span class="set-time-text">{{
                  t('feature_waste.waste-settings-menu.at')
                }}</span>
                <ion-datetime-button
                  datetime="datetimeSameDay"
                ></ion-datetime-button>
                <ion-modal [keepContentsMounted]="true">
                  <ng-template>
                    <ion-datetime
                      presentation="time"
                      id="datetimeSameDay"
                      (ionChange)="onDateTimeChange(reminderDay.sameDay)"
                      mode="ios"
                      [(ngModel)]="datetimeSameDay"
                      [showDefaultButtons]="true"
                      [doneText]="t('ui.date-time.done')"
                      [cancelText]="t('ui.date-time.cancel')"
                    ></ion-datetime>
                  </ng-template>
                </ion-modal>
              </ion-row>
            </div>
          </ion-radio>
        </div>

        <div class="waste-type-container flex-list-small">
          <div
            class="waste-type-subheader"
            *ngIf="wasteTypeErrored || wasteTypes.length"
          >
            {{ t('feature_waste.waste-settings-menu.for_which_waste_type') }}
          </div>

          <div *ngIf="wasteTypeErrored" class="error-message">
            {{ t('feature_waste.waste-settings-menu.waste_type_error') }}
          </div>

          <form
            class="flex-list-small"
            [formGroup]="wasteTypeForm"
            *ngIf="!wasteTypeErrored"
          >
            <lib-checkbox-setting
              *ngFor="let wasteType of wasteTypes"
              [localizedTitle]="t('feature_waste.waste_types.' + wasteType)"
              [checked]="wasteTypeForm.controls[wasteType].value"
              (checkedChange)="onWasteTypeCheckedChange(wasteType, $event)"
            >
            </lib-checkbox-setting>
          </form>
        </div>
      </ion-radio-group>
    </div>
  }
</ion-grid>
